#include<algorithm>
#include<fstream>
#include<string>
#include<cmath>
#include<cstdio>
#include<vector>

typedef vector<vector<int> > magic;
magic square;

int sum(int x, int y, int r)
{
	if (x >= square.size() || y >= square.size())
		return 0;
	switch(r) {
		case 0:
			return square[x][y] + sum(x+1,y,r);
		break;
		case 1:
			return square[x][y] + sum(x,y+1,r);
		break;
		case 2:
			return square[x][y] + sum(x+1,y-1,r);
		break;
		case 3:
			return square[x][y] + sum(x+1,y+1,r);
		break;
		
	}
}

bool calculate()
{
	int s = sum(0, 0, 0);
	
	for (int n=1;n<square.size();n++) {
		if (sum(n, 0, 1) != s)
			return false;
		if (sum(0, n, 0) != s)
			return false;
	}

	if (sum(0, 0,3) != s)
		return false;
	if (sum(0, square.size()-1, 2) != s)
		return false;
	return true;
		
}

int main()
{

	ifstream is("magic.in");
	int number = 1;
	while (1) {
		int n = 0;
		is >> n ;
		if (n == 0)
			break;
		square.clear();
		for (int x=0;x<n;x++)  {
			vector<int> tmp;
			for (int y =0;y<n;y++) {
				int blub;
				is >> blub;
				tmp.push_back(blub);
			}
			square.push_back(tmp);
		}
		cout << "Square " << number++ << endl;
		if (calculate())
			cout << "This square is magic." << endl;
		else
			cout << "This square is not magic." << endl;
		cout << endl;
		
	}
}
	
